﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System.Drawing;
using System.Windows.Forms;

namespace WinTreeFutureRequest
{
    class UITree : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        NodeConnectorUIElement forLong;
        List< NodeConnectorUIElement> lastrootfordraw = new List<NodeConnectorUIElement>() ;


        public void AfterCreateChildElements(UIElement parent)
        {
            TreeNodeUIElement tnui;
            UltraTreeNodeCellUIElement tncui;

            tncui = parent as UltraTreeNodeCellUIElement;
            //to remouve the old expandable button from column that is displaed in
            if (tncui != null && tncui.Column.Key == "Drug")
            {
                    Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement rem = (Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement)
                        tncui.GetDescendant(typeof(Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement));
                    if (rem != null)
                        tncui.ChildElements.Remove(rem);
            }

            tnui = parent as TreeNodeUIElement;
            if (tnui != null)
            {
                
                if (tnui.Node.Parent == null)
                {
                    PreNodeAreaUIElement pnui = new PreNodeAreaUIElement(tnui);
                    pnui.Rect = new Rectangle(new Point(tnui.Rect.Location.X + 50, tnui.Rect.Location.Y), new Size(20, 17));
                    Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement exui = new Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement(pnui);
                    exui.Rect = new Rectangle(new Point(pnui.Rect.Location.X + 50,pnui.Rect.Location.Y), new Size(15, 15));
                    tnui.ChildElements.Add(pnui);
                    forLong = null;
                    if (lastrootfordraw.Count > 0)
                    {
                        foreach (UIElement el in lastrootfordraw)
                            el.Rect = new Rectangle(el.Rect.Location, new Size(20, 20));
                    }
                    lastrootfordraw.Clear();
                   
                }
                else
                {
                    
                    //lastroot = null;
                    NodeClientAreaUIElement cl = (NodeClientAreaUIElement)tnui.Parent;
                    NodeConnectorUIElement ncui = new NodeConnectorUIElement(cl);
                    ncui.Rect = new Rectangle(new Point(tnui.Rect.Location.X + 50, tnui.Rect.Location.Y), new Size(0, 0));
                    cl.ChildElements.Add(ncui);
                    lastrootfordraw.Add(ncui);

                    NodeConnectorUIElement ncui1 = new NodeConnectorUIElement(cl);
                    ncui1.Rect = new Rectangle(new Point(tnui.Rect.Location.X + 55, tnui.Rect.Location.Y), new Size(20, 10));
                    cl.ChildElements.Add(ncui1);

                    if (forLong != null)
                        forLong.Rect = new Rectangle(forLong.Rect.Location, new Size(20, 20));

                    forLong = ncui1;

                    PreNodeAreaUIElement pnui = new PreNodeAreaUIElement(tnui);
                    pnui.Rect = new Rectangle(new Point(tnui.Rect.Location.X + 55, tnui.Rect.Location.Y), new Size(20, 17));
                    Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement exui = new Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement(pnui);
                    exui.Rect = new Rectangle(new Point(pnui.Rect.Location.X + 55, pnui.Rect.Location.Y), new Size(15, 15));
                    if (!exui.Node.HasNodes)
                        exui.Node.Expanded = true;
                    tnui.ChildElements.Add(pnui);
                }

            }
            //throw new NotImplementedException();
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;//throw new NotImplementedException();
        }

        #endregion
    }
}
